package io.malloc.ccc.ccc_fplugin;

import com.wolfssl.wolfcrypt.Aes;

import java.util.Arrays;

import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.malloc.ccc.nc.AesTest;
import io.malloc.ccc.cc.AesCipher;
import io.malloc.ccc.nc.Util;

/** CccFpluginPlugin */
public class CccFpluginPlugin implements MethodCallHandler {
  /**
   * Plugin registration.
   */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "ccc_fplugin");
    channel.setMethodCallHandler(new CccFpluginPlugin());
  }

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    byte[] iv;
    byte[] key;
    byte[] pData;
    byte[] eData;
    AesCipher aes;
    Aes enc;
    Aes dec;
    try {
      switch (call.method) {
        case "getPlatformVersion":
          result.success("Android " + android.os.Build.VERSION.RELEASE);
          break;
        //
        // Tests
        //
        case "aesTest":
          AesTest aesTest = new AesTest();
          aesTest.testEncDec();
          result.success("yay");
          break;
        //
        // Encrypt String
        //
        case "aesEnc":
          System.out.println("[J3G] 111");
          iv = call.argument("iv");
          key = call.argument("key");
          pData = ((String)call.argument("pText")).getBytes("UTF-8");
          System.out.println("[J3G] 222");
          aes = new AesCipher(key, iv, true);
          System.out.println("[J3G] 333");
          eData =  aes.enc(pData);
          System.out.println("[J3G] 444");
          aes.destroy();
          result.success(eData);
          break;
        //
        // Encrypt Uint
        //
        case "aesEncUint":
//          pData = call.argument("pData");
//          String hexStr1 = Util.b2h(pData);
//          System.out.println(hexStr1);

          System.out.println("[J3G] 111");
          iv = call.argument("iv");
          key = call.argument("key");
          pData = call.argument("pData");
          System.out.println("[J3G] 222");
          aes = new AesCipher(key, iv, true);
          System.out.println("[J3G] 333");
          eData =  aes.enc(pData);
          aes.destroy();
          result.success(eData);
          break;
        //
        // Decrypt
        //
        case "aesDec":
          iv = call.argument("iv");
          key = call.argument("key");
          byte[] cData = call.argument("cData");
          aes = new AesCipher(key, iv, false);
          pData = aes.dec(cData);
          aes.destroy();
          result.success(pData);
//          dec = new Aes(key, iv, Aes.DECRYPT_MODE);
//          byte[] decText = dec.update(cData, 0, cData.length);
//          dec.releaseNativeStruct();
//          result.success(decText);
          break;
        default:
          result.notImplemented();
      }
    }
    catch (Exception ex) {
      System.out.println("[ERR] exception: "+ex);
    }

  }
}
